
# 頥 祭   ᫮
proc mc:weather:enable {} {
  global mc mcweather
  if {[array exist mcweather] && [mc:chkflag weather.enbl]} { return 1 } { return 0 }
}

proc mc:weather:getstat {wth stat} {
  global mcweather

  if {$stat=="default" || $stat=="-"} { set stat "ono itak default daet" }

  switch -- $stat {
    ver  { return [lindex $mcweather($wth) 0] }
    fail { return [lindex $mcweather($wth) 1] }
    default {
      if {[set i [lsearch -exact $mcweather($wth) $stat]]==-1} {
        if {[set i [lsearch -exact $mcweather($wth) default]]==-1} {
          putlog "!!!Error in mc:weather:getstat <$wth> <$stat>"
          return "#error#"
        }
        return [lindex $mcweather($wth) [expr $i + 1]]
      }
      set ret [lindex $mcweather($wth) [expr $i + 1]]
      return [lindex $ret [rand [llength $ret]]]
    }
  }
}

proc mc:weather:changeweather {prev} {
  global mcweather

  if {$prev=="-"} {
    return [lindex [array names mcweather] [rand [llength [array names mcweather]]]]
  }
  set verl [mc:weather:getstat $prev ver]
  set rand [rand 100]
  foreach ver $verl {
    if {$rand<=[lindex $ver 1]} { return [lindex $ver 0] }
  }
  return $prev
}

proc mc:weather:set {} {
  global mc mcweather
  if {![mc:weather:enable]} { return }

  set prevweath "-"
  if {[info exist mc(weather)] && [info exist mcweather($mc(weather))]} { set prevweath $mc(weather) }
  set mc(weather) [mc:weather:changeweather $prevweath]
  mc:say "[mc:weather:getstat $mc(weather) $prevweath]"
}

#頥 ப  fail
#  <failtype>=generic - "<bool> <bool>" : <ᨫ__㪨> <ᨫ__ࣥ>
#  <failtype>=grom    - <num> : 0 -  ஬, 1 - ஬ ࠡ⠫ (⭮ 뢠  )
#  <failtype>=molniya - <num> : 0 -  , 1 -  ࠡ⠫ (⭮ 뢠  )
proc mc:weather:getfail {wth failtype} {
  set dodo [mc:weather:getstat $wth fail]
  set failm [set failg [set failbow [set failtarg 0]]]
  foreach fail $dodo {
    switch -- [lindex $fail 0] {
      bow     { set failbow  [lindex $fail 1] }
      targ    { set failtarg [lindex $fail 1] }
      grom    { set failg    [lindex $fail 1] }
      molniya { set failm    [lindex $fail 1] }
    }
  }
  if {$failtype=="generic"} { return "$failbow $failtarg" }
  set ret 0
  if {$failtype=="grom" && $failg>=[expr [rand 100]+1]} { set ret 1 }
  if {$failtype=="molniya" && $failm>=[expr [rand 100]+1]} { set ret 1 }
  return $ret
}

# 뢥   ᮮ饭  fail
proc mc:weather:sayfail {wth nklist failtype} {
  global wfail wfailadd
  if {$nklist==""} { return }

  set nks ""
  foreach id $nklist { lappend nks [mc:getstat nick $id] }

  switch -- $failtype {
    grom    {
      mc:say [xformat3 $wfailadd(${wth}${failtype}) [mc:getstat sex [lindex $nklist 0]] [ms:dfl $nks]]
    }
    molniya {
      mc:say [xformat3 $wfailadd(${wth}${failtype}) [mc:getstat sex [lindex $nklist 0]] [ms:dfl $nks]]
    }
    default {
      if {[llength $nklist]>1} {
        set nks [ms:dfl "[join [lrange $nks 0 [expr [llength $nks] - 2]] $wfail(join)]$wfail(and)[lindex $nks end]"]
        mc:say [format $wfail(${wth}n${failtype}) $nks]
      } {
        mc:say [xformat3 $wfail(${wth}1${failtype}) [mc:getstat sex [lindex $nklist 0]] [ms:dfl $nks]]
      }
    }
  }
}

proc mc:weather:findfail {nklist failstr} {

  set res  ""
  set dres ""
  set nklist [lsort -real -decreasing -index 1 $nklist]
  set maxstr [lindex [lindex $nklist 0] 1]
  set minstr [lindex [lindex $nklist end] 1]

  set tofail ""
  foreach rec $nklist {
    set str [lindex $rec 1]

    # ᫥ ⭮  ઠ
    # ᫨ ᨬ쭠 ઠ ⮣ ver=1, ᫨ 쭠, ⮣ ver=1.5
    if {$maxstr==$minstr} {
      set ver 1
    } {
      set ver [expr 1.5 - 0.5 * ($str - $minstr) / ($maxstr - $minstr) ]
    }

    # 㬭 ⭮ ப  ⭮ fail
    set ver [expr $ver * $failstr]
    # 뢠 祫  fail-list ᫨ ⭮ 諠
    if {$ver>=[rand 100]} {
      lappend res [lindex $rec 0]
      lappend dres "[lindex $rec 0] $ver"
    }
  }
  if { $dres != "" } {
    set out ""
    foreach rec $dres {
      lappend out [format "[red]%s[hblk]\[[cl]%.2f[hblk]\][cl]" [lindex $rec 0] [lindex $rec 1]]
    }
    putlog "[cyn]Fails: [join $out {, }]"
  }

  return $res
}

# 䨫  㤠 ,   諨 - 
proc mc:weather:filt {} {
  global mc mcweather
  global todo liv
  global tl ts ti twis
  if {![mc:weather:enable] || ![info exist mc(weather)] || ![info exist mcweather($mc(weather))]} { return }

  set fail [mc:weather:getfail $mc(weather) generic]
  if {$fail=="0 0"} { return }

  set livcount [llength [mc:game:livlist]]
  if { $livcount < 15 } {
    set wmod [expr 1.0 * $livcount / 15]
    putlog [format "[cyn]Weather mod[hblk] ==[cl] %.2f [hblk]\([cl]%s chars[hblk]\)[cl]" $wmod $livcount]
  } {
    set wmod 1.0
  }

  set nfail ""
  foreach ofail $fail {
    lappend nfail [expr 1.0 * $ofail * $wmod]
  }
  set fail $nfail
  putlog [format "[cyn]Weather fail: [grn]bow[hblk]\([cl]%.2f[hblk]\)[cl], [grn]att[hblk]\([cl]%.2f[hblk]\)[cl]" [lindex $fail 0] [lindex $fail 1]]


  set latt ""
  set lbow ""
  set lspl ""
  foreach id [array names liv] {
    switch -- [mc:getstat prof $id] {
      w {
        if { [mc:user:longweapon $id] } {
          lappend lbow "$id [expr2 1 1.0 * ($tl($id) * 0.6) + ($ti($id) * 0.3)]"
        } {
          lappend latt "$id [expr2 1 1.0 * ($tl($id) * 0.6) + ($ts($id) * 0.3)]"
        }
      }
      m { lappend latt "$id [expr2 1 1.0 * ($tl($id) * 0.6) + ($ts($id) * 0.3)]"
          lappend lspl "$id [expr ($twis($id) * 0.4) + ($ti($id) * 0.6)]"
      }
      p { lappend latt "$id [expr2 1 1.0 * ($tl($id) * 0.6) + ($ts($id) * 0.3)]"
          lappend lspl "$id [expr ($twis($id) * 0.6) + ($ti($id) * 0.4)]"
      }
    }
  }

  if {[lindex $fail 0]!=0 && $lbow!=""} {
    set tofail [mc:weather:findfail $lbow [lindex $fail 0]]
    set realfail ""
    #室 todo-list  㤠塞   ७ ⠪ 筨
    foreach id [array names todo] {
      if {[lsearch -exact $tofail $id]==-1} { continue }
      set newdo ""
      foreach do $todo($id) {
        if {[lindex $do 0]=="a"} {
          if {[lsearch -exact $realfail $id]==-1} { lappend realfail $id }
        } {
          lappend newdo $do
        }
      }
      set todo($id) $newdo
    }
    mc:weather:sayfail $mc(weather) $realfail bow
  }

  if {[lindex $fail 1]!=0 && $latt!=""} {
    set tofail [mc:weather:findfail $latt [lindex $fail 1]]
    set realfail ""
    #室 todo-list  㤠塞   ७ ⠪ .
    foreach id [array names todo] {
      if {[lsearch -exact $tofail $id]==-1} { continue }
      set newdo ""
      foreach do $todo($id) {
        if {[lindex $do 0]=="a"} {
          if {[lsearch -exact $realfail $id]==-1} { lappend realfail $id }
        } {
          lappend newdo $do
        }
      }
      set todo($id) $newdo
    }
    mc:weather:sayfail $mc(weather) $realfail att
  }

  if {[lindex $fail 1]!=0 && $lspl!=""} {
    set tofail [mc:weather:findfail $lspl [lindex $fail 1]]
    set realfail ""
    #室 todo-list  㤠塞   ७ ⠪ 筨
    foreach id [array names todo] {
      if {[lsearch -exact $tofail $id]==-1} { continue }
      set newdo ""
      foreach do $todo($id) {
        if {[lindex $do 0]=="m" && [mc:magic:getstat targ [lindex $do 3]] && [lindex $do 2] != $id } {
          if {[lsearch -exact $realfail $id]==-1} { lappend realfail $id }
        } {
          lappend newdo $do
        }
      }
      set todo($id) $newdo
    }
    mc:weather:sayfail $mc(weather) $realfail spell
  }
}

proc mc:weather:preapply {} {
  global mc mcweather
  global todo liv
  if {![mc:weather:enable] || ![info exist mc(weather)] || ![info exist mcweather($mc(weather))]} { return }
  if {![mc:weather:getfail $mc(weather) grom]} { return }
  set id [lindex [array names liv] [rand [array size liv]]]
  if {[lsearch -exact $todo($id) run]==-1} { set todo($id) "" } { set todo($id) "run" }
  mc:weather:sayfail $mc(weather) $id grom
}

proc mc:weather:postapply {} {
  global mc mcweather
  global todo liv th
  if {![mc:weather:enable] || ![info exist mc(weather)] || ![info exist mcweather($mc(weather))]} { return }
  if {![mc:weather:getfail $mc(weather) molniya]} { return }
  set id [lindex [array names liv] [rand [array size liv]]]
  if {$th($id)>0} { set th($id) 0 }
  mc:weather:sayfail $mc(weather) $id molniya
}

proc mc:weather:load {} {
  global mc
  global mcweather
  global wfail wfailadd


  putlog "Loading weather..."
  if {[array exist mcweather]} { unset mcweather }
  if {![file exists "$mc(file.weath).conf"]} {
    putlog "Warning! Weather file \($mc(file.weath).conf\) not found."
    return
  }

  set fid [open "$mc(file.weath).conf" r]
  while {![eof $fid]} {
    gets $fid line
    mc:stripline line
    if {[llength [split $line]]<2 && [string index $line 0] != "\["} { continue }
    if {[join [lindex [split $line] 0]]=="\[weather\]"} {
      set curweath  [join [lindex [split $line] 1]]
      set curverstr ""
      set curdefstr ""
      set curfailstr ""
      set curphrasestr ""
      set allver 0
      continue
    } elseif {[join [lindex [split $line] 0]]=="\[end\]"} {
      set realver ""
      set xver     0
      foreach ver $curverstr {
        set xver [expr $xver + round(100.0 * [lindex $ver 1] / $allver)]
        lappend realver "[lindex $ver 0] $xver"
      }
      set mcweather($curweath) "\{$realver\} \{$curfailstr\} default \{$curdefstr\} $curphrasestr"
      set curweath ""
      continue
    }
    if {$curweath==""} { continue }
    set line [split $line]
    set param [join [lrange $line 1 end]]
    switch -- [lindex $line 0] {
      ver       {
        lappend curverstr $param
        set allver [expr $allver + [lindex $param 1]]
      }
      "default" { set curdefstr $param }
      failver   { set curfailstr $param }
      fail {
        set wfail($curweath[lindex $line 1]) [join [lrange $line 2 end]]
      }
      addfail {
        set wfailadd($curweath[lindex $line 1]) [join [lrange $line 2 end]]
      }
      default {
        lappend curphrasestr [join [lindex $line 0]]
        lappend curphrasestr $param
      }
    }
  }

  close $fid
  if {![array exist mcweather]} {
    putlog "Warning! Weather records not found."
  }
}